pub fn part1(input: &str) -> u32 {
    let mut left_vec = vec![];
    let mut right_vec = vec![];

    for line in input.lines() {
        let (left, right) = line.split_once("   ").unwrap();
        left_vec.push(left.parse::<u32>().unwrap());
        right_vec.push(right.parse::<u32>().unwrap());
    }

    left_vec.sort();
    right_vec.sort();

    left_vec.into_iter().zip(right_vec.into_iter())
        .map(|(a, b)| a.abs_diff(b))
        .sum()
}

pub fn part2(input: &str) -> u32 {
    let mut left_vec = vec![];
    let mut right_arr = [0u32; 99999];

    for line in input.lines() {
        let (left, right) = line.split_once("   ").unwrap();

        left_vec.push(left.parse::<u32>().unwrap());
        right_arr[right.parse::<usize>().unwrap()] += 1;
    }

    left_vec.iter()
        .fold(0u32, |acc, left_value| acc + left_value * right_arr[*left_value as usize])
}

#[cfg(test)]
mod test {
    use crate::default_tests;
    use super::*;

    default_tests!(day01, 2344935, 27647262);
}