pub mod day01;
pub mod day02;
pub mod day03;
pub mod day04;
pub mod day05;
pub mod day06;
pub mod day07;
pub mod day08;
pub mod day09;
pub mod day10;
pub mod day11;
pub(crate) mod utils;

#[macro_export]
macro_rules! aoc_benchmark_day {
    ($day:ident) => {
        use aoc24::$day::{part1, part2};
        use criterion::{black_box, criterion_group, criterion_main, Criterion};

        pub fn benchmark(c: &mut Criterion) {
            let input = include_str!(concat!("../input/", stringify!($day), ".txt"));

            c.bench_function(concat!(stringify!($day), "_part1"), |b| {
                b.iter(|| part1(black_box(input)))
            });
            c.bench_function(concat!(stringify!($day), "_part2"), |b| {
                b.iter(|| part2(black_box(input)))
            });
        }

        criterion_group!(benches, benchmark);
        criterion_main!(benches);
    };
}

#[macro_export]
macro_rules! default_tests {
    ($day:ident, $expected_1:expr, $expected_2:expr) => {
        const DEFAULT_INPUT: &'static str =
            include_str!(concat!("../input/", stringify!($day), ".txt"));

        #[test]
        fn test_real_1() {
            assert_eq!(part1(DEFAULT_INPUT), $expected_1);
        }

        #[test]
        fn test_real_2() {
            assert_eq!(part2(DEFAULT_INPUT), $expected_2);
        }
    };
}
